<template>
  <client-only>
    <div class="relative">
      <!-- Hero Banner -->
      <section id="heroBanner" class="bg-secondary-100">
        <transition name="fade">
          <HeroCarousel />
        </transition>
      </section>

      <section id="store" class="bg-secondary-100">
        <div class="flex flex-col-reverse grid-cols-12 lg:grid">
          <aside
            id="store-aside"
            class="flex flex-col-reverse w-full p-8 lg:col-span-3 lg:flex-col"
          >
            <!-- Filters -->
            <div
              class="relative p-5 transition-all duration-300 ease-in-out bg-white border border-transparent rounded shadow-lg hover:border-primary-300 hover:shadow-xl"
            >
              <form
                id="products-filter"
                class="grid grid-cols-2 gap-5"
                @submit.prevent="filters($event)"
              >
                <div class="col-span-2 p-3 rounded bg-secondary-200">
                  <client-only>
                    <label class="block">
                      <span class="font-semibold text-white">Seach</span>
                      <input
                        id="search-input"
                        ref="search-input"
                        v-model="formValues.search"
                        type="text"
                        class="block w-full mt-1 form-input"
                        placeholder="Look for something"
                      />
                    </label>
                  </client-only>
                </div>

                <div
                  class="col-span-2 p-3 transition-all duration-300 ease-in-out rounded hover:bg-secondary-100"
                >
                  <client-only>
                    <label class="block">
                      <span class="font-semibold text-black">Category</span>
                      <select
                        id="category-input"
                        ref="category-input"
                        v-model="formValues.category"
                        class="block w-full mt-1 form-select"
                      >
                        <option value="">All categories</option>
                        <client-only v-if="categoriesToFilter">
                          <option
                            v-for="(category, index) in categoriesToFilter"
                            :key="index"
                            :value="category.slug"
                            class="capitalize"
                          >
                            {{
                              category.slug
                                .split('-')
                                .join(' ')
                                .replace(/\b\w/g, (l) => l.toUpperCase())
                            }}
                          </option>
                        </client-only>
                      </select>
                    </label>
                  </client-only>
                </div>

                <div
                  class="col-span-2 p-3 transition-all duration-300 ease-in-out rounded hover:bg-secondary-100"
                >
                  <client-only>
                    <label class="block">
                      <span class="font-semibold text-black">Brand</span>
                      <select
                        id="brand-input"
                        ref="brand-input"
                        v-model="formValues.brand"
                        class="block w-full mt-1 form-select"
                      >
                        <option value="">All brands</option>
                        <client-only v-if="brandsToFilter">
                          <option
                            v-for="(brand, index) in brandsToFilter"
                            :key="index"
                            :value="brand.slug"
                          >
                            {{ brand.name }}
                          </option>
                        </client-only>
                      </select>
                    </label>
                  </client-only>
                </div>

                <div
                  class="col-span-2 p-3 transition-all duration-300 ease-in-out rounded hover:bg-secondary-100"
                >
                  <span class="block font-semibold text-black">Color</span>
                  <div
                    v-if="colorsToFilter"
                    class="flex flex-wrap items-center justify-start"
                  >
                    <client-only>
                      <label
                        v-for="(color, index) in colorsToFilter"
                        :key="index"
                        class="color-checkbox"
                        :for="`checkbox-${color.slug}`"
                        :title="color.name"
                      >
                        <input
                          :id="`checkbox-${color.slug}`"
                          v-model="formValues.color"
                          type="radio"
                          name="colors"
                          :value="color.slug"
                        />
                        <span :style="`background-color: ${color.slug}`"></span>
                      </label>
                    </client-only>
                  </div>
                </div>

                <!-- <pre v-if="colorsToFilter">
                  {{ colorsToFilter }}
                </pre> -->

                <div
                  class="col-span-2 p-3 transition-all duration-300 ease-in-out rounded hover:bg-secondary-100"
                >
                  <span class="font-semibold text-black">Price range</span>
                  <div class="grid grid-cols-2 gap-5">
                    <div class="col-span-1">
                      <client-only>
                        <label class="block">
                          <input
                            id="min-price-input"
                            ref="min-price-input"
                            v-model="formValues.minPrice"
                            type="number"
                            class="block w-full mt-1 form-input"
                            placeholder="$min."
                          />
                        </label>
                      </client-only>
                    </div>
                    <div class="col-span-1">
                      <client-only>
                        <label class="block">
                          <input
                            id="max-price-input"
                            ref="max-price-input"
                            v-model="formValues.maxPrice"
                            type="number"
                            class="block w-full mt-1 form-input"
                            placeholder="$max."
                          />
                        </label>
                      </client-only>
                    </div>
                  </div>
                </div>

                <div
                  class="col-span-2 p-3 transition-all duration-300 ease-in-out rounded hover:bg-secondary-100"
                >
                  <client-only>
                    <label class="block">
                      <span class="font-semibold text-black">Order by</span>
                      <select
                        id="orderBy-input"
                        ref="orderBy-input"
                        v-model="formValues.field"
                        class="block w-full mt-1 form-select"
                      >
                        <option value="DATE">Date</option>
                        <!-- <option value="IN">IN</option> -->
                        <!-- <option value="MENU_ORDER">MENU_ORDER</option> -->
                        <!-- <option value="MODIFIED">MODIFIED</option> -->
                        <!-- <option value="NAME_IN">NAME_IN</option> -->
                        <!-- <option value="ON_SALE_FROM">ON_SALE_FROM</option> -->
                        <!-- <option value="ON_SALE_TO">ON_SALE_TO</option> -->
                        <!-- <option value="PARENT">PARENT</option> -->
                        <option value="PRICE">Price</option>
                        <option value="REGULAR_PRICE">Regular Price</option>
                        <option value="SALE_PRICE">Sale Price</option>
                        <!-- <option value="RATING">RATING</option> -->
                        <!-- <option value="REVIEW_COUNT">REVIEW_COUNT</option> -->
                        <!-- <option value="SLUG">SLUG</option> -->
                        <option value="TOTAL_SALES">Total Sales</option>
                      </select>
                    </label>
                  </client-only>
                </div>

                <div
                  class="col-span-2 p-3 transition-all duration-300 ease-in-out rounded hover:bg-secondary-100"
                >
                  <client-only>
                    <label class="block">
                      <span class="font-semibold text-black">Sort</span>
                      <select
                        id="order-input"
                        ref="order-input"
                        v-model="formValues.order"
                        class="block w-full mt-1 form-select"
                      >
                        <option value="DESC">DESC</option>
                        <option value="ASC">ASC</option>
                      </select>
                    </label>
                  </client-only>
                </div>

                <div class="col-span-2 mt-5">
                  <button type="submit" class="btn large secondary">
                    Filter
                  </button>
                </div>
              </form>
            </div>

            <!-- Featured Products -->
            <div id="featured-products" class="grid gap-5 mt-10 grid-col-1">
              <div>
                <h3 class="mb-5 text-xl font-medium">Featured products</h3>
                <div v-if="!featuredProducts">
                  <div v-for="index in featured.perPage" :key="index">
                    <TeaserSkeletonHorizontal class="mb-5 last:mb-0" />
                  </div>
                </div>

                <div v-else>
                  <div
                    v-for="(product, index) in featuredProducts.nodes"
                    :key="index"
                  >
                    <TeaserHorizontal
                      class="mb-5 last:mb-0"
                      :product="product"
                    />
                  </div>
                </div>
              </div>
            </div>
          </aside>

          <section id="store-products" class="w-full p-8 lg:col-span-9">
            <div>
              <div>
                <!-- Pagination -->
                <section
                  id="pagination-counts"
                  class="flex items-center justify-between mb-5"
                >
                  <h3 class="text-xl font-medium">Store</h3>
                  <p
                    v-if="products"
                    class="text-sm text-right text-secondary-300"
                  >
                    Showing {{ pagination.perPage * pagination.step + 1 }} to
                    <span
                      v-if="
                        pagination.perPage * pagination.currentPage <
                        pagination.total
                      "
                    >
                      {{ pagination.perPage * pagination.currentPage }}
                    </span>
                    <span v-else>
                      {{ pagination.total }}
                    </span>
                    of {{ pagination.total }} results
                  </p>
                </section>

                <!-- Skeleton -->
                <section v-show="!pagination.load" id="skeleton">
                  <ul
                    class="space-y-12 sm:grid sm:grid-cols-2 sm:gap-x-6 sm:gap-y-12 sm:space-y-0 lg:grid-cols-3 lg:gap-x-8"
                  >
                    <li
                      v-for="index in pagination.perPage"
                      :key="index"
                      class="relative"
                    >
                      <TeaserSkeleton />
                    </li>
                  </ul>
                </section>

                <!-- Products -->
                <section v-show="pagination.load" id="products-grid">
                  <ul
                    v-if="products"
                    class="space-y-12 sm:grid sm:grid-cols-2 sm:gap-x-6 sm:gap-y-12 sm:space-y-0 lg:grid-cols-3 lg:gap-x-8"
                  >
                    <li
                      v-for="(product, index) in products.nodes"
                      :key="index"
                      :class="[
                        { hidden: $route.query.onSale && !product.onSale },
                        'relative',
                      ]"
                    >
                      <Teaser v-show="pagination.load" :product="product" />
                    </li>
                  </ul>

                  <div id="pagination" class="mt-16">
                    <div class="container mx-auto">
                      <div
                        v-if="products"
                        class="flex items-center justify-center"
                      >
                        <div class="w-full lg:w-1/3">
                          <div class="grid grid-cols-3">
                            <div class="flex justify-start">
                              <button
                                :class="[
                                  {
                                    'text-secondary-200 pointer-events-none': !products
                                      .pageInfo.hasPreviousPage,
                                  },
                                  {
                                    'text-secondary-400':
                                      products.pageInfo.hasPreviousPage,
                                  },
                                  'flex items-center justify-center mr-10 focus:outline-none hover:text-primary-300 focus:text-primary-400',
                                ]"
                                @click="paginationDirection('prev')"
                              >
                                <i
                                  class="mr-2 text-3xl bx bx-chevron-left group-hover:text-primary-400 text-primary-300"
                                ></i>
                                Previous
                              </button>
                            </div>

                            <div class="text-center">
                              <span class="text-lg font-semibold">
                                {{ pagination.currentPage }}
                              </span>
                            </div>

                            <div class="flex justify-end">
                              <button
                                :class="[
                                  {
                                    'text-secondary-200 pointer-events-none': !products
                                      .pageInfo.hasNextPage,
                                  },
                                  {
                                    'text-secondary-400':
                                      products.pageInfo.hasNextPage,
                                  },
                                  'group flex items-center justify-center ml-10 focus:outline-none hover:text-primary-300 focus:text-primary-400',
                                ]"
                                @click="paginationDirection('next')"
                              >
                                Next
                                <i
                                  class="ml-2 text-3xl bx bx-chevron-right group-hover:text-primary-400 text-primary-300"
                                ></i>
                              </button>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </section>
              </div>
            </div>
          </section>
        </div>
      </section>
    </div>
  </client-only>
</template>

<script>
import HeroCarousel from '~/components/layout/parts/hero/HeroCarousel'
import Teaser from '~/components/product/Teaser'
import TeaserSkeleton from '~/components/product/TeaserSkeleton'
import TeaserHorizontal from '~/components/product/TeaserHorizontal'
import TeaserSkeletonHorizontal from '~/components/product/TeaserSkeletonHorizontal'

import getProducts from '~/apollo/queries/products/getProducts.gql'
import getProductCategories from '~/apollo/queries/store/getProductCategories.gql'
import getBrands from '~/apollo/queries/store/getBrands.gql'
import getColors from '~/apollo/queries/store/getColors.gql'

export default {
  components: {
    HeroCarousel,
    Teaser,
    TeaserSkeleton,
    TeaserHorizontal,
    TeaserSkeletonHorizontal,
  },
  data() {
    return {
      pagination: {
        load: false,
        step: 0,
        currentPage: 1,
        total: null,
        perPage: this.$route.query.onSale ? 25 : 9,
        startCursor: [''],
        endCursor: [''],
      },
      featured: {
        perPage: 5,
      },
      formValues: {},
      filterVariable: null,
    }
  },
  mounted() {
    if (this.$route.query.maxPrice)
      this.formValues.maxPrice = this.$route.query.maxPrice
  },
  apollo: {
    products: {
      prefetch: true,
      query: getProducts,
      variables() {
        function getWhere(that) {
          // console.log('that', that)
          if (that.filterVariable || that.$route.query) {
            // console.log('if query', that.$route.query)
            if (
              that.$route.query.onSale ||
              that.$route.query.search ||
              that.$route.query.maxPrice
            ) {
              if (that.$route.query.onSale) {
                // console.log('OFFER')
                return { onSale: true }
              } else if (that.$route.query.maxPrice) {
                return { maxPrice: parseInt(that.$route.query.maxPrice) }
              } else {
                // console.log('SEARCH OR NONE')
                return { search: that.$route.query.search }
              }
            } else {
              // console.log('QUERY')
              return that.filterVariable
            }
          } else {
            // console.log('ELSE')
            return {}
          }
        }

        // console.log(getWhere(this), 'test')
        // console.log(
        //   this.pagination.perPage,
        //   this.pagination.endCursor[this.pagination.step],
        //   getWhere(this)
        // )
        return {
          first: this.pagination.perPage * this.pagination.currentPage,
          after: this.pagination.endCursor[this.pagination.step],
          where: getWhere(this),
        }
      },
      update(data) {
        // console.log(data)
        this.pagination.load = true
        this.pagination.total =
          data.products.pageInfo.offsetPagination.total +
          this.pagination.step * this.pagination.perPage
        return data.products
      },
    },
    featuredProducts: {
      prefetch: true,
      query: getProducts,
      variables() {
        return {
          first: this.featured.perPage,
          where: {
            featured: true,
          },
        }
      },
      update(data) {
        return data.products
      },
    },
    categoriesToFilter: {
      prefetch: true,
      query: getProductCategories,
      variables() {},
      update(data) {
        return data.productCategories.nodes
      },
    },
    brandsToFilter: {
      prefetch: true,
      query: getBrands,
      variables() {},
      update(data) {
        return data.paBrands.nodes
      },
    },
    colorsToFilter: {
      prefetch: true,
      query: getColors,
      variables() {},
      update(data) {
        return data.paColors.nodes
      },
    },
  },
  methods: {
    paginationDirection(direction) {
      this.pagination.startCursor[
        this.pagination.currentPage
      ] = this.products.pageInfo.startCursor

      this.pagination.endCursor[
        this.pagination.currentPage
      ] = this.products.pageInfo.endCursor

      this.pagination.load = false

      switch (direction) {
        case 'prev':
          this.pagination.step--
          break
        case 'next':
          this.pagination.step++
          break
      }

      this.pagination.currentPage = this.pagination.step + 1

      document.getElementById('store').scrollIntoView()
    },
    filters(event) {
      const where = {}

      for (const key in this.formValues) {
        switch (key) {
          case 'minPrice':
          case 'maxPrice':
            where[key] = parseFloat(this.formValues[key])
            break

          case 'field':
          case 'order':
            where.orderby
              ? (where.orderby[0][key] = this.formValues[key])
              : (where.orderby = [{}])
            where.orderby[0][key] = this.formValues[key]
            break

          case 'search':
          case 'brand':
          case 'color':
            if (!where.search) {
              where.search = ''
              where.search += `${this.formValues[key]} `
            } else {
              where.search += `${this.formValues[key]} `
            }
            break

          default:
            where[key] = this.formValues[key]
            break
        }
      }

      if (Object.keys(this.$route.query).length !== 0) this.$router.replace({})

      document.getElementById('store').scrollIntoView()
      this.pagination.load = false
      this.filterVariable = where
    },
  },
}
</script>

<style lang="postcss">
label.color-checkbox {
  @apply block p-1 relative overflow-hidden cursor-pointer;
}
label.color-checkbox > input {
  @apply absolute h-0 w-0 left-0 top-0 -ml-1 -mt-1;
}
label.color-checkbox > input + span {
  @apply h-6 w-6 flex shadow-md rounded;
}
label.color-checkbox:hover > input + span,
label.color-checkbox > input:checked + span {
  @apply opacity-75 shadow-xl border border-primary-300;
}
</style>
